using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Infragistics.Win.UltraWinTree;

namespace UltraTree_Drag_and_Drop_CS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal Infragistics.Win.UltraWinTree.UltraTree UltraTree1;
		internal System.Windows.Forms.ImageList ImageList1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			UltraTree_DropHightLight_DrawFilter.Invalidate += new EventHandler(this.UltraTree_DropHightLight_DrawFilter_Invalidate);
			UltraTree_DropHightLight_DrawFilter.QueryStateAllowedForNode += new UltraTree_DropHightLight_DrawFilter_Class.QueryStateAllowedForNodeEventHandler(this.UltraTree_DropHightLight_DrawFilter_QueryStateAllowedForNode);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.UltraTree1 = new Infragistics.Win.UltraWinTree.UltraTree();
			this.ImageList1 = new System.Windows.Forms.ImageList(this.components);
			((System.ComponentModel.ISupportInitialize)(this.UltraTree1)).BeginInit();
			this.SuspendLayout();
			// 
			// UltraTree1
			// 
			this.UltraTree1.AllowDrop = true;
			this.UltraTree1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.UltraTree1.Location = new System.Drawing.Point(0, 2);
			this.UltraTree1.Name = "UltraTree1";
			this.UltraTree1.Size = new System.Drawing.Size(200, 304);
			this.UltraTree1.TabIndex = 1;
			this.UltraTree1.TopNode = null;
			this.UltraTree1.DragOver += new System.Windows.Forms.DragEventHandler(this.UltraTree1_DragOver);
			this.UltraTree1.DragDrop += new System.Windows.Forms.DragEventHandler(this.UltraTree1_DragDrop);
			this.UltraTree1.QueryContinueDrag += new System.Windows.Forms.QueryContinueDragEventHandler(this.UltraTree1_QueryContinueDrag);
			this.UltraTree1.DragLeave += new System.EventHandler(this.UltraTree1_DragLeave);
			this.UltraTree1.SelectionDragStart += new System.EventHandler(this.UltraTree1_SelectionDragStart);
			// 
			// ImageList1
			// 
			this.ImageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.ImageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.ImageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ImageList1.ImageStream")));
			this.ImageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(200, 309);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.UltraTree1});
			this.Name = "Form1";
			this.Text = "UltraWinTree Drag/Drop";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.UltraTree1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		//Create a new instance of the DrawFilter class to 
		//Handle drawing the DropHighlight/DropLines
		private UltraTree_DropHightLight_DrawFilter_Class UltraTree_DropHightLight_DrawFilter = new UltraTree_DropHightLight_DrawFilter_Class();

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//Attach the Drawfiler to the tree
			UltraTree1.DrawFilter = UltraTree_DropHightLight_DrawFilter;

			//Populate the Tree with Data
			LoadTree();

			UltraTree1.Override.SelectionType = Infragistics.Win.UltraWinTree.SelectType.ExtendedAutoDrag;
		}

		//This proc populates the tree with continents and countries.
		//They are all set up on the root level so you can have
		//fun putting the countries under the right continent. :)
		private void LoadTree()
		{
			UltraTreeNode ContinentNode;
			UltraTreeNode CountryNode;
			
			UltraTree1.Appearances.Add("DropHighLightAppearance");
			UltraTree1.Appearances["DropHighLightAppearance"].BackColor = Color.Cyan;
			
			UltraTree1.ImageList = ImageList1;
			ContinentNode = UltraTree1.Nodes.Add("Continent:North America", "North America");
			ContinentNode = UltraTree1.Nodes.Add("Continent:South America", "South America");
			ContinentNode = UltraTree1.Nodes.Add("Continent:Antarctica", "Antarctica");
			ContinentNode = UltraTree1.Nodes.Add("Continent:Europe", "Europe");
			ContinentNode = UltraTree1.Nodes.Add("Continent:Asia", "Asia");
			ContinentNode = UltraTree1.Nodes.Add("Continent:Africa", "Africa");
			ContinentNode = UltraTree1.Nodes.Add("Continent:Australia", "Australia");

			CountryNode = UltraTree1.Nodes.Add("Australia");
			CountryNode.Override.NodeAppearance.Image = 0;
			CountryNode.Tag = "Australia";
			CountryNode = UltraTree1.Nodes.Add("Austria");
			CountryNode.Override.NodeAppearance.Image = 1;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Belgium");
			CountryNode.Override.NodeAppearance.Image = 2;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Brazil");
			CountryNode.Override.NodeAppearance.Image = 3;
			CountryNode.Tag = "South America";
			CountryNode = UltraTree1.Nodes.Add("Canada");
			CountryNode.Override.NodeAppearance.Image = 4;
			CountryNode.Tag = "North America";
			CountryNode = UltraTree1.Nodes.Add("Denmark");
			CountryNode.Override.NodeAppearance.Image = 5;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Finland");
			CountryNode.Override.NodeAppearance.Image = 6;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("France");
			CountryNode.Override.NodeAppearance.Image = 7;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Germany");
			CountryNode.Override.NodeAppearance.Image = 8;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Ireland");
			CountryNode.Override.NodeAppearance.Image = 9;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Italy");
			CountryNode.Override.NodeAppearance.Image = 10;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Japan");
			CountryNode.Override.NodeAppearance.Image = 11;
			CountryNode.Tag = "Asia";
			CountryNode = UltraTree1.Nodes.Add("Mexico");
			CountryNode.Override.NodeAppearance.Image = 12;
			CountryNode.Tag = "North America";
			CountryNode = UltraTree1.Nodes.Add("Netherlands");
			CountryNode.Override.NodeAppearance.Image = 13;
			CountryNode.Tag = "Asia?";
			CountryNode = UltraTree1.Nodes.Add("Norway");
			CountryNode.Override.NodeAppearance.Image = 14;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("New Zealand");
			CountryNode.Override.NodeAppearance.Image = 15;
			CountryNode.Tag = "Asia";
			CountryNode = UltraTree1.Nodes.Add("Portugal");
			CountryNode.Override.NodeAppearance.Image = 16;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Republic of South Africa");
			CountryNode.Override.NodeAppearance.Image = 17;
			CountryNode.Tag = "Africa";
			CountryNode = UltraTree1.Nodes.Add("Russian Federation");
			CountryNode.Override.NodeAppearance.Image = 18;
			CountryNode.Tag = "Asia";
			CountryNode = UltraTree1.Nodes.Add("Korea");
			CountryNode.Override.NodeAppearance.Image = 19;
			CountryNode.Tag = "Asia";
			CountryNode = UltraTree1.Nodes.Add("Spain");
			CountryNode.Override.NodeAppearance.Image = 20;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Sweden");
			CountryNode.Override.NodeAppearance.Image = 21;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Switzerland");
			CountryNode.Override.NodeAppearance.Image = 22;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("Turkey");
			CountryNode.Override.NodeAppearance.Image = 23;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("United Kingdom");
			CountryNode.Override.NodeAppearance.Image = 24;
			CountryNode.Tag = "Europe";
			CountryNode = UltraTree1.Nodes.Add("United States");
			CountryNode.Override.NodeAppearance.Image = 25;
			CountryNode.Tag = "North America";		
		}

		//This event will fire when the user attempts to drag
		//a node. 
		private void UltraTree1_SelectionDragStart(object sender, System.EventArgs e)
		{			
			//Start a DragDrop operation
			UltraTree1.DoDragDrop(UltraTree1.SelectedNodes, DragDropEffects.Move); 
		}

		//The DragDrop event. Here we respond to a Drop on the tree
		private void UltraTree1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			//A dummy node variable used for various things
			UltraTreeNode aNode;
			//The SelectedNodes which will be dropped
			SelectedNodesCollection SelectedNodes;
			//The Node to Drop On
			Infragistics.Win.UltraWinTree.UltraTreeNode DropNode;
			//An integer used for loops
			int i;

			//Set the DropNode
			DropNode = UltraTree_DropHightLight_DrawFilter.DropHightLightNode;

			//Get the Data and put it into a SelectedNodes collection,
			//then clone it and work with the clone
			//These are the nodes that are being dragged and dropped
			SelectedNodes = (SelectedNodesCollection)e.Data.GetData(typeof(SelectedNodesCollection));
			SelectedNodes = SelectedNodes.Clone() as SelectedNodesCollection;

			//Sort the selected nodes into their visible position. 
			//This is done so that they stay in the same order when
			//they are repositioned. 
			SelectedNodes.SortByPosition();

			//Determine where we are dropping based on the current
			//DropLinePosition of the DrawFilter
			switch (UltraTree_DropHightLight_DrawFilter.DropLinePosition)
			{
				case DropLinePositionEnum.OnNode: //Drop ON the node
				{
					//Loop through the SelectedNodes and reposition
					//them to the node that was dropped on.
					//Note that the DrawFilter keeps track of what
					//node the mouse is over, so we can just use
					//DropHighLightNode as the drop target. 
					for (i = 0;i<= (SelectedNodes.Count - 1);i++)
					{
						aNode = SelectedNodes[i];						
						aNode.Reposition(DropNode.Nodes);
					}
					break;
				}
				case DropLinePositionEnum.BelowNode: //Drop Below the node
				{					
					for (i = 0;i<= (SelectedNodes.Count - 1);i++)
					{
						aNode = SelectedNodes[i];						
						aNode.Reposition(DropNode,Infragistics.Win.UltraWinTree.NodePosition.Next);
					    //Change the DropNode to the node that was
						//just repositioned so that the next 
						//added node goes below it. 
						DropNode = aNode;
					}	
					break;
				}
				case DropLinePositionEnum.AboveNode: //New Index should be the same as the Drop
				{
					for (i = 0;i<= (SelectedNodes.Count - 1);i++)
					{
						aNode = SelectedNodes[i];						
						aNode.Reposition(DropNode,Infragistics.Win.UltraWinTree.NodePosition.Previous);
					}
					break;
				}
			}

			//After the drop is complete, erase the current drop
			//highlight. 
			UltraTree_DropHightLight_DrawFilter.ClearDropHighlight();
		}

		private void UltraTree1_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			//A dummy node variable used to hold nodes for various 
			//things
			UltraTreeNode aNode;
			//The Point that the mouse cursor is on, in Tree coords. 
			//This event passes X and Y in form coords. 
			System.Drawing.Point PointInTree;

			//Get the position of the mouse in the tree, as opposed
			//to form coords
			PointInTree = UltraTree1.PointToClient(new Point(e.X, e.Y));

			//Get the node the mouse is over.
			aNode = UltraTree1.GetNodeFromPoint(PointInTree);

			//Make sure the mouse is over a node
			if (aNode == null)
			{
				//The Mouse is not over a node
				//Do not allow dropping here
				e.Effect = DragDropEffects.None;
				//Erase any DropHighlight
				UltraTree_DropHightLight_DrawFilter.ClearDropHighlight();
				//Exit stage left
				return;
			}

		
			//	Don't let continent nodes be dropped onto other continent nodes
			if ( this.IsContinentNode(aNode) && this.IsContinentNodeSelected( this.UltraTree1 ) )
			{
				if ( PointInTree.Y > (aNode.Bounds.Top + 2) &&
					 PointInTree.Y < (aNode.Bounds.Bottom - 2) )
				{
					e.Effect = DragDropEffects.None;
					UltraTree_DropHightLight_DrawFilter.ClearDropHighlight();
					return;
				}
			}

			//Check to see if we are dropping onto a node who//s
			//parent (grandparent, etc) is selected.
			//This is to prevent the user from dropping a node onto
			//one of it//s own descendents. 
			if (IsAnyParentSelected(aNode))
			{
				//Mouse is over a node whose parent is selected
				//Do not allow the drop
				e.Effect = DragDropEffects.None;
				//Clear the DropHighlight
				UltraTree_DropHightLight_DrawFilter.ClearDropHighlight();
				//Exit stage left
				return;
			}
			
			//If we//ve reached this point, it//s okay to drop on this node
			//Tell the DrawFilter where we are by calling SetDropHighlightNode
			UltraTree_DropHightLight_DrawFilter.SetDropHighlightNode(aNode, PointInTree);
			//Allow Dropping here. 
			e.Effect = DragDropEffects.Move;
		}

		//Proc to check whether a node is a continent or not. 
		//This is necessary because we only want continents to be 
		//parent nodes. We don't want countries to contain other
		//countries
		private bool IsContinentNode(UltraTreeNode Node)
		{
			//The Key of the node
			string NodeKey;
			//The beginning of the key
			string[] ParsedNodeKey;

			//Get the key of the node
			NodeKey = Node.Key;

			//Parse it out by colon
			ParsedNodeKey = NodeKey.Split(':');
			
			//If the beginning of the key says Continent, then 
			//we know it's a continent node. 
			return (ParsedNodeKey[0] == "Continent");
		}

		/// <summary>
		/// Returns whether any of the currently selected nodes in the
		/// specified UltraTree control represent continents.
		/// </summary>
		/// <param name="tree">The UltraTree control to evaluate.</param>
		/// <returns>A boolean indicating whether any continent nodes are selected.</returns>
		private bool IsContinentNodeSelected( UltraTree tree )
		{
			foreach ( UltraTreeNode selectedNode in tree.SelectedNodes )
			{
				if ( this.IsContinentNode( selectedNode ) )
					return true;
			}

			return false;
		}

		//Test to see if we want to continue dragging		
		private void UltraTree1_QueryContinueDrag(object sender, System.Windows.Forms.QueryContinueDragEventArgs e)
		{
			//Did the user press escape? 
			if (e.EscapePressed)
			{
				//User pressed escape
				//Cancel the Drag
				e.Action = DragAction.Cancel;
				//Clear the Drop highlight, since we are no longer
				//dragging
				UltraTree_DropHightLight_DrawFilter.ClearDropHighlight();
			}
		}

		//Occassionally, the DrawFilter will let us know that the 
		//control needs to be invalidated. 
		private void UltraTree_DropHightLight_DrawFilter_Invalidate(object sender, System.EventArgs e)
		{
			//Any time the drophighlight changes, the control needs 
			//to know that it has to repaint. 
			//It would be more efficient to only invalidate the area
			//that needs it, but this works and is very clean.
			UltraTree1.Invalidate();
		}

		//This event is fired by the DrawFilter to let us determine
		//what kinds of drops we want to allow on any particular node
		private void UltraTree_DropHightLight_DrawFilter_QueryStateAllowedForNode(Object sender, UltraTree_DropHightLight_DrawFilter_Class.QueryStateAllowedForNodeEventArgs e )
		{
			//	Don't let continent nodes be dropped onto other continent nodes
			if ( this.IsContinentNode(e.Node) && this.IsContinentNodeSelected( this.UltraTree1 ) )
			{
				e.StatesAllowed = DropLinePositionEnum.AboveNode | DropLinePositionEnum.BelowNode;
				return;
			}

			//Check to see if this is a continent node. 
			if (!IsContinentNode(e.Node))
			{
				//This is not a continent
				//Allow users to drop above or below this node - but not on
				//it, because countries don//t have child countries
				e.StatesAllowed = DropLinePositionEnum.AboveNode | DropLinePositionEnum.BelowNode;
				
				//Since we can only drop above or below this node, 
				//we don//t want a middle section. So we set the 
				//sensitivity to half the height of the node
				//This means the DrawFilter will respond to the top half
				//bottom half of the node, but not the middle. 
				UltraTree_DropHightLight_DrawFilter.EdgeSensitivity = e.Node.Bounds.Height / 2;
			}
			else
			{
				if (e.Node.Selected)
				{
					//This is a selected Continent node. 
					//Since it is selected, we don't want to allow
					//dropping ON this node. But we can allow the
					//the user to drop above or below it. 
					e.StatesAllowed = DropLinePositionEnum.AboveNode | DropLinePositionEnum.BelowNode;
					UltraTree_DropHightLight_DrawFilter.EdgeSensitivity = e.Node.Bounds.Height / 2;
				}
				else
				{
					//This is a continent node and is not selected
					//We can allow dropping here above, below, or on this
					//node. Since the StatesAllow defaults to All, we don't 
					//need to change it. 
					//We set the EdgeSensitivity to 1/3 so that the 
					//Drawfilter will respond at the top, bottom, or 
					//middle of the node. 
					UltraTree_DropHightLight_DrawFilter.EdgeSensitivity = e.Node.Bounds.Height / 3;
				}
			}
		}

		//Walks up the parent chain for a node to determine if any
		//of it's parent nodes are selected
		private bool IsAnyParentSelected(UltraTreeNode Node) 
		{
			UltraTreeNode ParentNode;
			bool ReturnValue = false;

			ParentNode = Node.Parent;
			while (ParentNode != null)
			{
				if (ParentNode.Selected)
				{
					ReturnValue = true;
					break;
				}
				else
				{
					ParentNode = ParentNode.Parent;
				}
			} 

			return ReturnValue;
		}

		//Fires when the user drags outside the control. 
		private void UltraTree1_DragLeave(object sender, System.EventArgs e)
		{
			//When the mouse goes outside the control, clear the 
			//drophighlight. 
			//Since the DropHighlight is cleared when the 
			//mouse is not over a node, anyway, 
			//this is probably not needed
			//But, just in case the user goes from a node directly
			//off the control...
			UltraTree_DropHightLight_DrawFilter.ClearDropHighlight();
		}		
	}
}
